/* *******************
 * overlay.js
 * Implementation for mail and Firefox overlays
 *   rssEditor   <http://rsseditor.mozdev.org/>
 *
 * Author: Jed Brown (quicknote@jedbrown.net)
 * Contributor(s):
 *   Nickolay Ponomarev (asqueella@gmail.com)
 * Maintenance: Leunc WC (lwchk2001@yahoo.com.hk)
 ******************** */


// opens a new floating window
function rsseditor_float()
{
	window.openDialog("chrome://rsseditor/content/rsseditor.xul", "_blank", "chrome,all,dialog=no");
}
////////////////////////////////////////////////////////////////////////////////
// Desc: Opens rsseditor depending on set pref
// Have to add here because Mozilla Suite won't inherit rssEditor.js :(
////////////////////////////////////////////////////////////////////////////////
function rsseditor_open()
{
	var howtopen = 1;

	switch (howtopen)
	{
		case "0": toggleSidebar("viewrssEditorSidebar"); break;
		case "2": rsseditor_tab(); break;
		default: rsseditor_float();
	}
}


// Open rssEditor as a tab
//### taken from Download Manager Tweak dmextension.mozdev.org
function rsseditor_tab()
{
	var numTabs = gBrowser.mTabContainer.childNodes.length;
	var index = 0;
	var oldTab = getBrowser().selectedTab;

	if (oldTab.getAttribute("rssEditor") == "true")
	{
		if (getWebNavigation().currentURI.spec == "chrome://rsseditor/content/rsseditor.xul")
		{
			BrowserCloseTabOrWindow();
			return;
		}
		else
			oldTab.removeAttribute("rssEditor");
	}

	var tempTab = null;
	while (index < numTabs)
	{
		tempTab = gBrowser.mTabContainer.childNodes[index];

		if (tempTab.getAttribute("rssEditor") == "true")
		{
			if (tempTab.label == "rssEditor" || tempTab.label == "chrome://rsseditor/content/rsseditor.xul")
			{
				getBrowser().selectedTab = tempTab;
				break;
			}
			else
			{
				getBrowser().selectedTab = tempTab;
				var url = getWebNavigation().currentURI.spec;
				if (url == "chrome://rsseditor/content/rsseditor.xul") break;
				else tempTab.removeAttribute("rssEditor");
			}
		}
		else index = index+1;
	}

	// If no rssEditor tab is open, then create one
	if (index == numTabs)
	{
		var rssEditorTab = gBrowser.addTab("chrome://rsseditor/content/rsseditor.xul");
		rssEditorTab.setAttribute("rssEditor", "true");
		getBrowser().selectedTab = rssEditorTab;
	}
}
